var eventLog = {
    xml: null,
    handler: function(){
	var kill=new RegExp("You k[^\.]+");
        var alerts = content.document.getElementsByClassName("alert");
        for (a = 0; a < alerts.length; a++) {
            var check = this.dupeCheck(alerts[a].textContent);
            if (check) {
                (alerts[a].textContent.indexOf("successfully") != -1 && (mobwars.prefs.getBoolPref("tools.eventlogging.logHitlistAddsOther"))) ? this.appendToLog(alerts[a].textContent, "add") : '';
                (alerts[a].textContent.indexOf("killed") != -1 && (mobwars.prefs.getBoolPref("tools.eventlogging.logKills"))) ? this.appendToLog(kill.exec(alerts[a].textContent), "kill") : '';
            }
        }
        return;
    },
    appendToLog: function(msg, type){
        this.xml = rw.rFile("eventlog.xml","<announcements><\/announcements>");
        var xmlDoc = this.xml;
        var aNodes = this.evaluateXPath(xmlDoc, "//alert[contains(@id,null)]");
        var newANode = xmlDoc.createElement("alert");
        newANode.setAttribute("id", aNodes.length);
        newANode.setAttribute("type", type);
        var d = new Date();
        var date = d.toLocaleTimeString() + ' ' + d.toLocaleDateString();
        newANode.setAttribute("timestamp", date);
        newANode.textContent = msg;
        var ann = this.evaluateXPath(xmlDoc, "//announcements");
        ann[0].appendChild(newANode);
        // var r = this.evaluateXPath(xmlDoc,"//alert[contains(@id," + aNodes.length + ")]");
        var s = new XMLSerializer();
        var xml = s.serializeToString(xmlDoc);
        rw.wFile('eventlog.xml', xml,"<announcements>\r\n<\/announcements>");
    },
    evaluateXPath: function(aNode, aExpr){
        var xpe = new XPathEvaluator();
        var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ? aNode.documentElement : aNode.ownerDocument.documentElement);
        var result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
        var found = [];
        var res;
        while (res = result.iterateNext()) 
            found.push(res);
        return found;
    },
    clearLog: function(){
        this.xml = rw.rFile("eventlog.xml","<announcements>\r\n<\/announcements>");
        var xmlDoc = this.xml;
        var aNodes = this.evaluateXPath(xmlDoc, "//alert[contains(@id,null)]");
        for (var i in aNodes) 
            aNodes[i].parentNode.removeChild(aNodes[i]);
        var s = new XMLSerializer();
        var xml = s.serializeToString(xmlDoc);
        rw.wFile('eventlog.xml', xml,"<announcements>\r\n<\/announcements>");
        var q = document.getElementById("q1");
        q.setAttribute("expr", "alert[@type='null']");
        var t = document.getElementById("event-tree");
        t.builder.rebuild();
    },
    transformXML: function(){
        var p = new XSLTProcessor();
        var t = document.implementation.createDocument("", "test", null);
        t.addEventListener("load", onload, false);
        t.load("test-transform.xml");
        function onload(){
            processor.importStylesheet(t);
        }
    },
    dupeCheck: function(msg){
        this.xml = rw.rFile("eventlog.xml","<announcements>\r\n<\/announcements>");
        var xmlDoc = this.xml;
        var aNodes = this.evaluateXPath(xmlDoc, "//alert[text()]");
        for (i = 0; i < aNodes.length; i++) {
            if (aNodes[i] == msg) 
                return false;
        }
        return true;
    },
    openLog: function(){
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
var logWin = wm.getMostRecentWindow('mt_logwin');
        if (logWin == null || logWin.closed) {
            logWin = window.openDialog("chrome://mobtools/content/eventlog.xul", "el_window", "chrome,centerscreen,width=500,height=500,resizable,scrollbars=yes");
			logWin.addEventListener("load", function(){
            var t = logWin.document.getElementById("event-tree")
			rw.rFile("eventlog.xml","<announcements><\/announcements>");
			t.datasources = rw.path;
			// t.builder.rebuild();
        }, false);
        }
        else {
            logWin.focus();
        }
    },
    viewEvent: function(tree){
	cWin = null;
        cWin = window.openDialog("chrome://mobtools/content/copywindow.xul", "copywindow", "chrome,centerscreen,width=300,height=200,resizable,scrollbars=yes");
        cWin.addEventListener("load", function(){
		// alert('load');
            cWin.document.getElementById("etext").value = tree.view.getCellText(tree.currentIndex, tree.columns.getColumnAt(1));
            cWin.document.title = tree.view.getCellText(tree.currentIndex, tree.columns.getColumnAt(0));
        }, false);
    },
    refresh: function(){
        logWin.close();
        logWin = window.openDialog("chrome://mobtools/content/eventlog.xul", "el_window", "chrome,centerscreen,width=500,height=500,resizable,scrollbars=yes");
    },
    filter: function(type){
        var q = document.getElementById("q1");
        (type == 'clear') ? q.setAttribute("expr", "alert[@type]") : q.setAttribute("expr", "alert[@type = '" + type + "']");
        var t = document.getElementById("event-tree");
        t.builder.rebuild();
    },
    copy: function(){
        var text = document.getElementById("etext").value;
        var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
        str.data = text;
        var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
        trans.addDataFlavor("text/unicode");
        trans.setTransferData("text/unicode", str, text.length * 2);
        var clipid = Components.interfaces.nsIClipboard;
        var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
        clip.setData(trans, null, clipid.kGlobalClipboard);
        return;
    }
};


